# C221001A. 算术

## 题目描述

给定一个长为 $n$ 的数列 $a_i$，求有多少对 $i, j$ 满足 $i < j$，$a_i a_j < (a_i + a_j)$。

## 输入格式

第一行一个整数 $n$。

接下来一行 $n$ 个整数表示 $a_i$。

## 输出格式

输出一个整数表示答案。

## 样例

### 输入数据 1

```
6
0 -4 -9 9 1 -6
```

### 输出数据 1

```
9
```

## 数据规模与约定

| 数据点   | $n \leq$ | 特殊性质     |
| :------- | :------- | :----------- |
| 1,2,3    | $10^3$   | 无           |
| 4,5,6    | $10^6$   | $a_i \geq 0$ |
| 7,8,9,10 | $10^6$   | 无           |

对于全部数据：$-1 \times 10^9 \leq a_i \leq 1 \times 10^9$ 。

# C221001B. 刷墙

## 题目描述

有 $n$ 种颜色的刷子，一面墙壁。

第 $i$ 把刷子颜色为 $i$，会在墙壁的第 $l_i$ 米到 $r_i$ 米上刷上颜色 $i$。

你现在可以任意调整刷子的顺序，先刷的颜色会被后刷的颜色盖住。

问墙壁最终最多有多少**种**颜色。

## 输入格式

第一行一个整数 $n$。

接下来有 $n$ 行，每行两个整数表示 $l_i$，$r_i$。

## 输出格式

输出一个整数表示答案。

## 样例

### 输入数据 1

```plaintext
6
2 3
3 4
2 3
2 3
0 1
2 3
```

### 输出数据 1

```plaintext
3
```

## 数据规模与约定

| 数据点      | $n \leq$ |
| :---------- | :------- |
| 1           | 10       |
| 2, 3        | 20       |
| 4, 5, 6     | 100      |
| 7, 8, 9, 10 | 300      |

对于所有数据，$1 \leq n \leq 300, 0 \leq l_i < r_i \leq 10^9$。

# #C221001C. 重复

## 题目描述

对于一个字符串 $S$，一个划分是好的，当且仅当这种划分能把 $S$ 划分成 6 个非空子串 $a, b, c, d, e, f$，并且满足 $a=b=e$，$c=f$，以及 $d$ 为任意非空子串。例如，字符串 "141445144" 能被划分为 $a=14, b=14, c=4, d=5, e=14, f=4$ 。

一个字符串可能有多种划分方式。

现在给定字符串 $S$，问 $S$ 的所有子串的划分方案数之和是多少。（$S$ 的一个子串为 $S$ 的一个区间）

## 输入格式

输入一行一个字符串表示 $S$，保证 $S$ 的每个字符为 $0\sim9$ 的数字。

## 输出格式

输出一个整数，表示答案。

## 样例

### 输入数据 1

```input1
1111111
```

### 输出数据 1

```output1
3
```

## 数据规模与约定

对于所有数据 $|S| \leq 5000$。

| 数据点      | $|S| \leq$ |
| :---------- | :--------- |
| 1           | 20         |
| 2, 3        | 100        |
| 4, 5, 6     | 500        |
| 7, 8, 9, 10 | 5000       |

# #C221001D. 公交

## 题目描述

有 $n$ 座城市，彼此间通过 $n-1$ 条道路连接且 $n$ 座城市互相连通。

第 $i$ 座城市有 $a_i$ 个人。假设首都是 $r$，现在你要修建 $k$ 条到 $r$ 的公交线路。若你选择修建线路 $(u, r)$，则 $u$ 到 $r$ 上的所有点都将被包括在公交线路中。对于不在公交线路上的点，居民需要沿最短路径走到一条最近的被包括在公交线路的点上，所产生的不满度为此距离乘上该点的人数。

你需要合理规划这 $k$ 条线路，使得不满度之和最小。同时，你需要求出首都为 $1 \sim n$ 的所有情况的答案。

## 输入格式

第一行两个整数 $n, k$。

第二行 $n$ 个整数表示 $a_i$。

接下来的 $n-1$ 行每行两个整数 $u, v$ 表示一条边。

## 输出格式

输出一行 $n$ 个整数表示首都为 $1 \ldots n$ 时的答案。

## 样例

### 输入数据 1

```
5 2
82822 92268 1983 93812 57626 
1 2
2 3
2 4
4 5
```

### 输出数据 1

```
0 1983 0 1983 0
```

## 数据规模与约定

| 数据点 | $n \leq$        | $k \leq$ |
| ------ | --------------- | -------- |
| 1      | $100$           | $n$      |
| 2, 3   | $10^3$          | $n$      |
| 4      | $10^5$          | $1$      |
| 5, 6   | $10^{5}$        | $10$     |
| 7, 8   | $10^{5}$        | $n$      |
| 9, 10  | $5 \times 10^5$ | $n$      |

对于所有数据，$1 \leq k \leq n \leq 2 \times 10^5, 0 \leq a_i \leq 10^5$。
